diff --git a/src/backend/commands/publicationcmds.c b/src/backend/commands/publicationcmds.c
index 8e645741e4..c939ae689a 100644
--- a/src/backend/commands/publicationcmds.c
+++ b/src/backend/commands/publicationcmds.c
@@ -922,7 +922,7 @@ AlterPublicationOptions(ParseState *pstate, AlterPublicationStmt *stmt,
 							  &publish_via_partition_root_given,
 							  &publish_via_partition_root);
 
-	pubform = (Form_pg_publication) GETSTRUCT(tup);
+	pubform = GETSTRUCT(pg_publication, tup);
 
 	/*
 	 * If the publication doesn't publish changes via the root partitioned
@@ -1038,7 +1038,7 @@ AlterPublicationOptions(ParseState *pstate, AlterPublicationStmt *stmt,
 
 	CommandCounterIncrement();
 
-	pubform = (Form_pg_publication) GETSTRUCT(tup);
+	pubform = GETSTRUCT(pg_publication, tup);
 
 	/* Invalidate the relcache. */
 	if (pubform->puballtables)
@@ -1114,7 +1114,7 @@ AlterPublicationTables(AlterPublicationStmt *stmt, HeapTuple tup,
 					   const char *queryString)
 {
 	List	   *rels = NIL;
-	Form_pg_publication pubform = (Form_pg_publication) GETSTRUCT(tup);
+	Form_pg_publication pubform = GETSTRUCT(pg_publication, tup);
 	Oid			pubid = pubform->oid;
 
 	/*
@@ -1291,7 +1291,7 @@ static void
 AlterPublicationSchemas(AlterPublicationStmt *stmt,
 						HeapTuple tup, List *schemaidlist)
 {
-	Form_pg_publication pubform = (Form_pg_publication) GETSTRUCT(tup);
+	Form_pg_publication pubform = GETSTRUCT(pg_publication, tup);
 
 	/*
 	 * Nothing to do if no objects, except in SET: for that it is quite
@@ -1355,7 +1355,7 @@ static void
 CheckAlterPublication(AlterPublicationStmt *stmt, HeapTuple tup,
 					  List *tables, List *schemaidlist)
 {
-	Form_pg_publication pubform = (Form_pg_publication) GETSTRUCT(tup);
+	Form_pg_publication pubform = GETSTRUCT(pg_publication, tup);
 
 	if ((stmt->action == AP_AddObjects || stmt->action == AP_SetObjects) &&
 		schemaidlist && !superuser())
@@ -1407,7 +1407,7 @@ AlterPublication(ParseState *pstate, AlterPublicationStmt *stmt)
 				 errmsg("publication \"%s\" does not exist",
 						stmt->pubname)));
 
-	pubform = (Form_pg_publication) GETSTRUCT(tup);
+	pubform = GETSTRUCT(pg_publication, tup);
 
 	/* must be owner */
 	if (!pg_publication_ownercheck(pubform->oid, GetUserId()))
@@ -1482,7 +1482,7 @@ RemovePublicationRelById(Oid proid)
 		elog(ERROR, "cache lookup failed for publication table %u",
 			 proid);
 
-	pubrel = (Form_pg_publication_rel) GETSTRUCT(tup);
+	pubrel = GETSTRUCT(pg_publication_rel, tup);
 
 	/*
 	 * Invalidate relcache so that publication info is rebuilt.
@@ -1520,7 +1520,7 @@ RemovePublicationById(Oid pubid)
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for publication %u", pubid);
 
-	pubform = (Form_pg_publication) GETSTRUCT(tup);
+	pubform = GETSTRUCT(pg_publication, tup);
 
 	/* Invalidate relcache so that publication info is rebuilt. */
 	if (pubform->puballtables)
@@ -1551,7 +1551,7 @@ RemovePublicationSchemaById(Oid psoid)
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for publication schema %u", psoid);
 
-	pubsch = (Form_pg_publication_namespace) GETSTRUCT(tup);
+	pubsch = GETSTRUCT(pg_publication_namespace, tup);
 
 	/*
 	 * Invalidate relcache so that publication info is rebuilt. See
@@ -1944,7 +1944,7 @@ AlterPublicationOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 {
 	Form_pg_publication form;
 
-	form = (Form_pg_publication) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_publication, tup);
 
 	if (form->pubowner == newOwnerId)
 		return;
@@ -2015,7 +2015,7 @@ AlterPublicationOwner(const char *name, Oid newOwnerId)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("publication \"%s\" does not exist", name)));
 
-	pubform = (Form_pg_publication) GETSTRUCT(tup);
+	pubform = GETSTRUCT(pg_publication, tup);
 	subid = pubform->oid;
 
 	AlterPublicationOwner_internal(rel, tup, newOwnerId);
diff --git a/src/backend/commands/schemacmds.c b/src/backend/commands/schemacmds.c
index be3925b3b4..204bd066fa 100644
--- a/src/backend/commands/schemacmds.c
+++ b/src/backend/commands/schemacmds.c
@@ -80,7 +80,7 @@ CreateSchemaCommand(CreateSchemaStmt *stmt, const char *queryString,
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for role %u", owner_uid);
 		schemaName =
-			pstrdup(NameStr(((Form_pg_authid) GETSTRUCT(tuple))->rolname));
+			pstrdup(NameStr((GETSTRUCT(pg_authid, tuple))->rolname));
 		ReleaseSysCache(tuple);
 	}
 
@@ -233,7 +233,7 @@ RenameSchema(const char *oldname, const char *newname)
 				(errcode(ERRCODE_UNDEFINED_SCHEMA),
 				 errmsg("schema \"%s\" does not exist", oldname)));
 
-	nspform = (Form_pg_namespace) GETSTRUCT(tup);
+	nspform = GETSTRUCT(pg_namespace, tup);
 	nspOid = nspform->oid;
 
 	/* make sure the new name doesn't exist */
@@ -313,7 +313,7 @@ AlterSchemaOwner(const char *name, Oid newOwnerId)
 				(errcode(ERRCODE_UNDEFINED_SCHEMA),
 				 errmsg("schema \"%s\" does not exist", name)));
 
-	nspform = (Form_pg_namespace) GETSTRUCT(tup);
+	nspform = GETSTRUCT(pg_namespace, tup);
 	nspOid = nspform->oid;
 
 	AlterSchemaOwner_internal(tup, rel, newOwnerId);
@@ -335,7 +335,7 @@ AlterSchemaOwner_internal(HeapTuple tup, Relation rel, Oid newOwnerId)
 	Assert(tup->t_tableOid == NamespaceRelationId);
 	Assert(RelationGetRelid(rel) == NamespaceRelationId);
 
-	nspForm = (Form_pg_namespace) GETSTRUCT(tup);
+	nspForm = GETSTRUCT(pg_namespace, tup);
 
 	/*
 	 * If the new owner is the same as the existing owner, consider the
diff --git a/src/backend/commands/sequence.c b/src/backend/commands/sequence.c
index 48d9d43dac..98c963e723 100644
--- a/src/backend/commands/sequence.c
+++ b/src/backend/commands/sequence.c
@@ -286,7 +286,7 @@ ResetSequence(Oid seq_relid)
 	pgstuple = SearchSysCache1(SEQRELID, ObjectIdGetDatum(seq_relid));
 	if (!HeapTupleIsValid(pgstuple))
 		elog(ERROR, "cache lookup failed for sequence %u", seq_relid);
-	pgsform = (Form_pg_sequence) GETSTRUCT(pgstuple);
+	pgsform = GETSTRUCT(pg_sequence, pgstuple);
 	startv = pgsform->seqstart;
 	ReleaseSysCache(pgstuple);
 
@@ -302,7 +302,7 @@ ResetSequence(Oid seq_relid)
 	 * Modify the copied tuple to execute the restart (compare the RESTART
 	 * action in AlterSequence)
 	 */
-	seq = (Form_pg_sequence_data) GETSTRUCT(tuple);
+	seq = GETSTRUCT(pg_sequence_data, tuple);
 	seq->last_value = startv;
 	seq->is_called = false;
 	seq->log_cnt = 0;
@@ -478,14 +478,14 @@ AlterSequence(ParseState *pstate, AlterSeqStmt *stmt)
 		elog(ERROR, "cache lookup failed for sequence %u",
 			 relid);
 
-	seqform = (Form_pg_sequence) GETSTRUCT(seqtuple);
+	seqform = GETSTRUCT(pg_sequence, seqtuple);
 
 	/* lock page's buffer and read tuple into new sequence structure */
 	(void) read_seq_tuple(seqrel, &buf, &datatuple);
 
 	/* copy the existing sequence data tuple, so it can be modified locally */
 	newdatatuple = heap_copytuple(&datatuple);
-	newdataform = (Form_pg_sequence_data) GETSTRUCT(newdatatuple);
+	newdataform = GETSTRUCT(pg_sequence_data, newdatatuple);
 
 	UnlockReleaseBuffer(buf);
 
@@ -676,7 +676,7 @@ nextval_internal(Oid relid, bool check_permissions)
 	pgstuple = SearchSysCache1(SEQRELID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(pgstuple))
 		elog(ERROR, "cache lookup failed for sequence %u", relid);
-	pgsform = (Form_pg_sequence) GETSTRUCT(pgstuple);
+	pgsform = GETSTRUCT(pg_sequence, pgstuple);
 	incby = pgsform->seqincrement;
 	maxv = pgsform->seqmax;
 	minv = pgsform->seqmin;
@@ -964,7 +964,7 @@ do_setval(Oid relid, int64 next, bool iscalled)
 	pgstuple = SearchSysCache1(SEQRELID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(pgstuple))
 		elog(ERROR, "cache lookup failed for sequence %u", relid);
-	pgsform = (Form_pg_sequence) GETSTRUCT(pgstuple);
+	pgsform = GETSTRUCT(pg_sequence, pgstuple);
 	maxv = pgsform->seqmax;
 	minv = pgsform->seqmin;
 	ReleaseSysCache(pgstuple);
@@ -1232,7 +1232,7 @@ read_seq_tuple(Relation rel, Buffer *buf, HeapTuple seqdatatuple)
 		MarkBufferDirtyHint(*buf, true);
 	}
 
-	seq = (Form_pg_sequence_data) GETSTRUCT(seqdatatuple);
+	seq = GETSTRUCT(pg_sequence_data, seqdatatuple);
 
 	return seq;
 }
@@ -1714,7 +1714,7 @@ sequence_options(Oid relid)
 	pgstuple = SearchSysCache1(SEQRELID, relid);
 	if (!HeapTupleIsValid(pgstuple))
 		elog(ERROR, "cache lookup failed for sequence %u", relid);
-	pgsform = (Form_pg_sequence) GETSTRUCT(pgstuple);
+	pgsform = GETSTRUCT(pg_sequence, pgstuple);
 
 	/* Use makeFloat() for 64-bit integers, like gram.y does. */
 	options = lappend(options,
@@ -1777,7 +1777,7 @@ pg_sequence_parameters(PG_FUNCTION_ARGS)
 	pgstuple = SearchSysCache1(SEQRELID, relid);
 	if (!HeapTupleIsValid(pgstuple))
 		elog(ERROR, "cache lookup failed for sequence %u", relid);
-	pgsform = (Form_pg_sequence) GETSTRUCT(pgstuple);
+	pgsform = GETSTRUCT(pg_sequence, pgstuple);
 
 	values[0] = Int64GetDatum(pgsform->seqstart);
 	values[1] = Int64GetDatum(pgsform->seqmin);
diff --git a/src/backend/commands/statscmds.c b/src/backend/commands/statscmds.c
index cd5e2f2b6b..68e599a104 100644
--- a/src/backend/commands/statscmds.c
+++ b/src/backend/commands/statscmds.c
@@ -238,7 +238,7 @@ CreateStatistics(CreateStatsStmt *stmt)
 						(errcode(ERRCODE_UNDEFINED_COLUMN),
 						 errmsg("column \"%s\" does not exist",
 								attname)));
-			attForm = (Form_pg_attribute) GETSTRUCT(atttuple);
+			attForm = GETSTRUCT(pg_attribute, atttuple);
 
 			/* Disallow use of system attributes in extended stats */
 			if (attForm->attnum <= 0)
@@ -754,7 +754,7 @@ RemoveStatisticsById(Oid statsOid)
 	if (!HeapTupleIsValid(tup)) /* should not happen */
 		elog(ERROR, "cache lookup failed for statistics object %u", statsOid);
 
-	statext = (Form_pg_statistic_ext) GETSTRUCT(tup);
+	statext = GETSTRUCT(pg_statistic_ext, tup);
 	relid = statext->stxrelid;
 
 	CacheInvalidateRelcacheByRelid(relid);
@@ -885,7 +885,7 @@ StatisticsGetRelation(Oid statId, bool missing_ok)
 			return InvalidOid;
 		elog(ERROR, "cache lookup failed for statistics object %u", statId);
 	}
-	stx = (Form_pg_statistic_ext) GETSTRUCT(tuple);
+	stx = GETSTRUCT(pg_statistic_ext, tuple);
 	Assert(stx->oid == statId);
 
 	result = stx->stxrelid;
diff --git a/src/backend/commands/subscriptioncmds.c b/src/backend/commands/subscriptioncmds.c
index bdc1208724..722d5337fc 100644
--- a/src/backend/commands/subscriptioncmds.c
+++ b/src/backend/commands/subscriptioncmds.c
@@ -990,7 +990,7 @@ AlterSubscription(ParseState *pstate, AlterSubscriptionStmt *stmt,
 				 errmsg("subscription \"%s\" does not exist",
 						stmt->subname)));
 
-	form = (Form_pg_subscription) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_subscription, tup);
 	subid = form->oid;
 
 	/* must be owner */
@@ -1362,7 +1362,7 @@ DropSubscription(DropSubscriptionStmt *stmt, bool isTopLevel)
 		return;
 	}
 
-	form = (Form_pg_subscription) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_subscription, tup);
 	subid = form->oid;
 
 	/* must be owner */
@@ -1652,7 +1652,7 @@ AlterSubscriptionOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 {
 	Form_pg_subscription form;
 
-	form = (Form_pg_subscription) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_subscription, tup);
 
 	if (form->subowner == newOwnerId)
 		return;
@@ -1705,7 +1705,7 @@ AlterSubscriptionOwner(const char *name, Oid newOwnerId)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("subscription \"%s\" does not exist", name)));
 
-	form = (Form_pg_subscription) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_subscription, tup);
 	subid = form->oid;
 
 	AlterSubscriptionOwner_internal(rel, tup, newOwnerId);
